<template>
  <div class="p-2">
    <el-dialog v-model="dialog.visible" :title="dialog.title" width="35%" :draggable="draggable">
      <el-form ref="formRef" v-loading="formLoading" :model="formData" :rules="formRules" label-width="80px">
        <el-form-item label="参数编码" prop="paramCode">
          <el-input v-model="formData.paramCode" placeholder="请输入参数编码" />
        </el-form-item>
        <el-form-item label="参数名称" prop="paramName">
          <el-input v-model="formData.paramName" placeholder="请输入参数名称" />
        </el-form-item>
        <el-form-item label="参数值" prop="paramValue">
          <el-input v-model="formData.paramValue" placeholder="请输入参数值" />
        </el-form-item>
        <el-form-item label="参数备注" prop="remark">
          <el-input v-model="formData.remark" placeholder="请输入参数备注" />
        </el-form-item>
        <el-form-item label="系统参数" prop="sysData">
          <el-select v-model="formData.sysData" placeholder="请选择系统参数">
            <el-option
                v-for="dict in sys_yes_no"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
            ></el-option>
          </el-select>
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="formLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="dialog.visible = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="PtParameterForm" lang="ts">
import * as PtParameterApi from '@/api/basics/basicParameter/ptParameter';
import { PtParameterForm } from '@/api/basics/basicParameter/ptParameter/types';
import { useI18n } from 'vue-i18n';

defineOptions({ name: 'PtParameterForm' });

// 接收父组件传入属性
// const props = defineProps({})

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
// 国际化
const { t } = useI18n();

/** 数据字典 */
const { sys_yes_no } = toRefs<any>(proxy?.useDict('sys_yes_no'));
// 对话框
const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});
// 窗体是否可以拖动
const draggable = ref(true);
// 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formLoading = ref(false);
// 表单的类型：create - 新增；update - 修改
const formType = ref('');
// 表单引用
const formRef = ref<ElFormInstance>();
// 表单数据
const formData = ref<PtParameterForm>({
  paramId: undefined,
  paramCode: '',
  paramName: '',
  paramValue: '',
  remark: '',
  sysData: '',
});
// 表单校验规则
const formRules = reactive({
  paramId: [{ required: true, message: '参数id不能为空', trigger: 'blur' }],
  paramCode: [{ required: true, message: '参数编码不能为空', trigger: 'blur' }],
  paramName: [{ required: true, message: '参数名称不能为空', trigger: 'blur' }],
  paramValue: [{ required: true, message: '参数值不能为空', trigger: 'blur' }],
  sysData: [{ required: true, message: '系统参数不能为空', trigger: 'change' }],
});
/** 当前组件方法 */
/** 窗体打开事件 */
const open = async (type: string, id?: number) => {
  dialog.visible = true;
  dialog.title = t('action.' + type);
  formType.value = type;
  resetForm();
  // 修改时，设置数据
  if (id) {
    formLoading.value = true;
    try {
      const res = await PtParameterApi.getPtParameter(id);
      Object.assign(formData.value, res.data);
    } finally {
      formLoading.value = false;
    }
  }
};
/** 表单重置 */
const resetForm = () => {
  formData.value = {
    paramId: undefined,
    paramCode: '',
    paramName: '',
    paramValue: '',
    remark: '',
    sysData: '',
  };
  formRef.value?.resetFields();
};
// 传回给父组件的属性与方法
// 提供 open 方法，用于打开弹窗
defineExpose({ open });
/** 触发父组件的事件 */
/** 定义 success 事件，用于操作成功后的回调 */
const emit = defineEmits(['success']);
/** 提交按钮 */
const submitForm = async () => {
  // 校验表单
  if (!formRef) return;
  const valid = await formRef.value?.validate();
  if (!valid) return;
  // 提交请求
  formLoading.value = true;
  try {
    const data = formData.value as unknown as PtParameterForm;
    if (formType.value === 'create') {
      await PtParameterApi.addPtParameter(data);
      proxy?.$modal.msgSuccess('新增成功');
    } else {
      await PtParameterApi.updatePtParameter(data);
      proxy?.$modal.msgSuccess('修改成功');
    }
    dialog.visible = false;
    // 发送操作成功的事件
    emit('success');
  } finally {
    formLoading.value = false;
  }
};

/** 初始化 */
onMounted(() => {});
</script>
